/*
 * part of puzzle.java
 * see main class for copyright
 * bernd@komplett.cc
 */

import java.awt.*;

class PiecesPanel extends Panel  {

	TextField textField;
	Scrollbar slider;
	Panel p;
	String title;
	int min = 2;
	int max;
	StatusBar sb; // = new StatusBar();

public PiecesPanel(String theTitle, int maxPieces, int startValue)  {
	
	max = maxPieces;
	title = theTitle;
	String startV = String.valueOf(startValue).toString();
	sb = new StatusBar();
	p = new Panel();

	setLayout(new GridLayout(0,1));
	p.setLayout(new FlowLayout());

	Label label = new Label(title, Label.CENTER);
	add(label);

	textField = new TextField(startV, 2);
	// textField.preferredSize(3);
	p.add(textField);

	slider = new Scrollbar(Scrollbar.HORIZONTAL, 2, 1, min, max);
	p.add(slider);
	add(p);
	setSliderValue(startValue);
}

public boolean handleEvent(Event e) {
	if (e.target instanceof Scrollbar) {
		textField.setText(String.valueOf(slider.getValue()));
		sb.showStatus("Click \"NEW\" now to update the image");

	} else if ((e.target instanceof TextField)  && (e.id == Event.ACTION_EVENT)) {
		setSliderValue(getValue());
		sb.showStatus("Click \"NEW\" now to update the image");
	}
	return super.handleEvent(e);
}

int getValue() {
	int i;
	try {
		i = Integer.valueOf(textField.getText()).intValue(); 
		if (i > max)
			i = max;
		if (i < min)
			i = min;
	} catch (java.lang.NumberFormatException e) {
		i = 2;
	}
	setValue(i);
	return i;
}

void setValue(int i) {
	setSliderValue(i);
	textField.setText(String.valueOf(i));
	sb.showStatus("NOW!!!");
}

void setSliderValue(int i) {
	int sliderValue = i;

	if (sliderValue > max)
		sliderValue = max;
	if (sliderValue < min)
		sliderValue = min;
	slider.setValue(sliderValue);
}

}  //end of class PiecesPanel!
