/*
* by bernd oeggl (bernd@komplett.cc)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* http://komplett.cc
* 
*****************************************************/

/*
 * a short version history:
 * 1.0.11: changed the setSize method in Yippea.class: some netscape versions
 * (MacOS) do not handle this correctly (resize() should work)
 */

/** 
 * @version 1.0.11 Mar. 2001
 * @version 1.0.10 Feb. 2001
 * @version 1.0.9 Oct. 1998 -- March 1997
 * @author bernd oeggl 
 * (<A HREF="mailto:bernd@komplett.cc">bernd@komplett.cc</A>)
 */

import java.applet.*;
import java.awt.*;
import java.util.Date;
import java.awt.image.*;

public class puzzle extends Applet implements Runnable {

	int number;
	int xPos = 0;
	int yPos = 0;
	int rows, cols;
	int imgSize[] = new int[2];
	int i_old, j_old;
	int X=10;
	int Y=10;
	int randNr[];
	int aWidth, aHeight;
	int maxPieces = 30;
	static final String version = "1.0.11";
	static final String date = "Feb. 2001";

	String imageFile;
	String imageDir=null;

	boolean move = false;
	boolean finished = false;
	boolean successPopup = false;
	boolean successRoot = true;

	Rectangle r;
	Rectangle pieces;

	PuzzleImage img[][];
	PuzzleImage imgToDraw;
	Image startImage = null;

	PuzzleCanvas pCv;

	Thread myThread;
	Graphics osGraphics;

	Button resultButton,aboutButton,
		shuffleButton, newPieces ;

	// we want to change the cursor from time to time
	Frame frame;

	MediaTracker mt = null;

	Result rs;
	StatusBar sb = new StatusBar();	// a custom statusbar
	About ab = new About("puzzle.java", version, date);
	PiecesPanel ppRows, ppCols; 

public String[][] getParameterInfo() {
	String[][] info = {
		{"rows",		"int",  "number of rows on startup"},
		{"cols",		"int",  "number of colums on startup"},
		{"maxPieces",		"int",  "maximum Number of Pieces"},
		{"Image",	"urls", "where we get our image from"},
		{"result",	"String", "one of 'popup' 'root' or 'none'"},
	};
	return info;
}

public String getAppletInfo()  {
	String aInfo = 
		"A simple puzzle-game to use with gif or jpeg \n"+ 
		"Images (Free Software (GPL) by bernd oeggl \"bernd@komplett.cc\")";
	return aInfo;
}

public void init()  {
	// get parameters from html-file:
	String Number = getParameter("rows");
	rows = Integer.valueOf(Number).intValue();
	Number = getParameter("maxPieces");
	maxPieces = Integer.valueOf(Number).intValue();
	Number = getParameter("cols");
	cols = Integer.valueOf(Number).intValue();
	Number = getParameter("width");
	aWidth = Integer.valueOf(Number).intValue();
	Number = getParameter("Height");
	aHeight = Integer.valueOf(Number).intValue();
	imageFile = getParameter("Image");
	Number = getParameter("result");
	if (Number != null) {
		if (Number.equalsIgnoreCase("popup")) 
			successPopup = true;
		else
			successPopup = false;
		if (Number.equalsIgnoreCase("root")) 
			successRoot = true;
		else 
			successRoot = false;
		if (Number.equalsIgnoreCase("none")) {
			successRoot = false;
			successPopup = false;
		}
	}

	initImg();

	// method setSize() not yet implemented (by Netscape) for Components
	// keep width and height for later on....
	pCv = new PuzzleCanvas(this, pieces.width, pieces.height);

	setBackground(Color.white);

	// MENU THINGS HERE :
	Font menuFont = new Font("SansSerif", Font.PLAIN, 12);

	ppRows = new PiecesPanel("Rows", maxPieces, rows);
	ppCols = new PiecesPanel("Colums", maxPieces, cols);
	Panel pSouth = new Panel();
	Panel pEast = new Panel();
	newPieces = new Button("Update Image");

	setFont(menuFont);
	pEast.setBackground(Color.gray);
	pSouth.setBackground(Color.gray);
	setLayout(new BorderLayout());

	// menu on the east side:
	pEast.setLayout(new GridLayout(0,1));
	pEast.add(aboutButton = new Button("About"));
	pEast.add(resultButton = new Button("Show Result"));
	pEast.add(shuffleButton= new Button("Shuffle"));

	GridBagLayout gridBag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	pSouth.setLayout(gridBag);

	// c.fill = GridBagConstraints.BOTH;
	// c.fill = GridBagConstraints.HORIZONTAL;

	// c.weightx = 1.0;
	// c.gridwidth = 3;
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.anchor = GridBagConstraints.WEST;
	gridBag.setConstraints(sb, c);
	pSouth.add(sb);

	// c.weightx = 1.0;
	// c.weighty = 1.0;
	c.gridwidth = 1;
	gridBag.setConstraints(ppRows, c);
	pSouth.add(ppRows);
	c.gridwidth = GridBagConstraints.RELATIVE;
	gridBag.setConstraints(ppCols, c);
	pSouth.add(ppCols);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridBag.setConstraints(newPieces, c);
	pSouth.add(newPieces);

	add("East", pEast);
	add("South", pSouth);
	add("Center", pCv);


	validate();
	frame.validate();

}

public void initImg()  {

	startImage = getImage(getCodeBase(), imageFile);

	// temporary, to get the whole Image
	MediaTracker mt = new MediaTracker(this);
	mt.addImage(startImage, 0);
	try  {
		mt.waitForAll();
	}  catch (InterruptedException e)  {
	}

	// repaint();
	rs = new Result(startImage, this);

	// to check if we are inside the pieces
	pieces = new Rectangle(0, 0, 
			startImage.getWidth(this),startImage.getHeight(this));

	// this is very(!) important! we split up our image here and
	// calculate some values we need later on
	img = splitImage(startImage, rows, cols);
	// System.out.println("image split complete");

	// we do not need this any longer...
	// mt = null;

	Object fr = getParent();
	while (!(fr instanceof Frame))
		fr = ((Component) fr).getParent();
	frame = (Frame)fr;

	validate();
	frame.validate();

}


/** splits the selected image to rows*cols pieces
 */
public PuzzleImage[][] splitImage(Image startImage, int rows, int cols)  {
	finished = false;
	mt = new MediaTracker(this);
	img = new PuzzleImage[cols][rows];
	number = rows*cols;
	imgSize[0] = startImage.getWidth(this)/rows;
	imgSize[1] = startImage.getHeight(this)/cols;
	// to check which is the piece we are moving
	r = new Rectangle(0,0, imgSize[0], imgSize[1]);

	for (int i = 0; i < cols; i++)  {
		for (int j = 0; j < rows; j++)  {
			xPos = j*imgSize[0];
			yPos = i*imgSize[1];
			ImageFilter myFilter = 
					new CropImageFilter(xPos, yPos, imgSize[0],  imgSize[1]);
			FilteredImageSource fims = 
					new FilteredImageSource(startImage.getSource(), myFilter);
			img[i][j] = new PuzzleImage(createImage(fims));
			mt.addImage(img[i][j].getImage(), 0);
		}
	}
	// shuffle up the images!
	img = shuffle(img);
	return img;
}

/** generate a list of rows*cols "random" numbers
 */
public int[] makeRandom(int number)  {
	int y;
	int ox[] =new int[number+1]; 
	int x[] = new int[number];
	for (int i=0;i<number;i++)  {
		y = (int)(Math.random()*number);
		x[i] = y;
		for (int j=1;j<=number;j++)  {
			if ((x[i] == ox[j-1])||(x[i]==0)) {
				x[i] +=1;
				if (x[i]>number) {
					x[i] =1;
				}	
				j=0; // go for another loop!!!
			}	
		}
		ox[i]=x[i];
	}
/* ---------------COMMENTS START HERE--------------- 
	// for debugging of the random function
	for (int l=0;l<number;l++)  {
		System.out.println("X[i]: "+x[l]+" OX[i] "+ox[l]);
	}
-----------------COMMENTS END--------------------- */ 
	return x;
}

public PuzzleImage[][] shuffle(PuzzleImage img[][])  {
	// someone should know the order of my puzzles!
	finished = false;
	int thisCount = 0;
	PuzzleImage imgTmp[] = new PuzzleImage[number];
	randNr = new int[number];
	randNr = makeRandom(number);		
	for (int i=0;i<cols;i++)  {
		for (int j=0;j<rows;j++)  {
			imgTmp[thisCount] = new PuzzleImage(img[i][j].getImage());
			thisCount++;
		}
	}
	thisCount = 0;
	for (int i=0;i<cols;i++)  {
		for (int j=0;j<rows;j++)  {
			img[i][j]= new 
				PuzzleImage(imgTmp[(randNr[thisCount])-1].getImage());
			img[i][j].setCorrPos(thisCount);
			img[i][j].setPos((randNr[thisCount])-1);
			thisCount++;
		}
	}
	// destroy it
	imgTmp = null;
	return img;
}

public void start()  {
	if (myThread == null)  {
		myThread = new Thread(this);
		myThread.start();
	}
}

public synchronized void run()  {
	pCv.repaint();
	frame.setCursor(Frame.WAIT_CURSOR);
	if (mt != null) {
		try  {
			mt.waitForAll();
		}  catch (InterruptedException e)  {}
	}
	// startTime = System.currentTimeMillis();
	pCv.repaint();
	sb.showStatus("Click on one piece and drag it to the correct location");
	frame.setCursor(Frame.DEFAULT_CURSOR);
}

public void stop()  {
	osGraphics = null;
	myThread = null;
}

public PuzzleImage locatePos(int x, int y)  {
	Rectangle inRect;
	for (int i = 0; i < cols; i++)  {
		for (int j = 0; j < rows; j++)  {
			xPos = j*imgSize[0];
			yPos = i*imgSize[1];
			inRect = new Rectangle(xPos, yPos, imgSize[0], imgSize[1]);
			if (inRect.inside(x,y))  {
				r = inRect;
				i_old = i; j_old = j;
				return img[i][j];
			}
		}
	}
	return img[0][0];
}

public void moveTo(int x, int y)  {
	Rectangle inRect;
	int count = 1;
	for (int i = 0; i < cols; i++)  {
		for (int j = 0; j < rows; j++)  {
			xPos = j*imgSize[0];
			yPos = i*imgSize[1];
			inRect = new Rectangle(xPos, yPos, imgSize[0], imgSize[1]);
			if (inRect.inside(x,y))  {
				PuzzleImage tmpImg = new PuzzleImage(img[i][j].getImage());
				tmpImg.setPos(img[i][j].getPos());
				img[i][j].setPos((img[i_old][j_old].getPos()));
				img[i][j].setImage(img[i_old][j_old].getImage());
				img[i_old][j_old].setImage(tmpImg.getImage());
				img[i_old][j_old].setPos(tmpImg.getPos());

				pCv.osGraphics.drawImage(imgToDraw.getImage(), 
						inRect.x, inRect.y, this);
				pCv.osGraphics.drawImage(img[i][j].getImage(), r.x, r.y, this);
			}
		}
	count++;
	}
	return;
}

public boolean mouseDown(Event e, int x, int y)  {
	if (pieces.inside(x,y))  {
		frame.setCursor(Frame.HAND_CURSOR);
		imgToDraw = locatePos(x,y);
	} else  {
		move = false;
	}
	return true;
}
public boolean mouseDrag(Event e, int x, int y)  {
	if (pieces.inside(x,y))  {
		move = true;
		X=x-imgSize[0]/2;Y=y-imgSize[1]/2;
		pCv.repaint();
	} else  {
		move = false;
	}
	return true;
}

public boolean checkResult() {
	int count = 0;
	int all = 0;
	for (int i=0;i<cols;i++)  {
		for (int j = 0; j < rows; j++)  {
			// System.out.println("Pos (img["+i+"]["+j+"] is: "
					// +img[i][j].getPos()+" and should be "+
					// img[i][j].getCorrPos());
			count++;
			if (img[i][j].getCorrPos() == img[i][j].getPos()) {
				all++;
			}
		}
	}
	if (count/2 > all) {
		sb.showStatus("You've got "+all+" out of "+count+" right ["+
				all+"/"+count+"]. Come on!");
	} else if (count-4 >= all) {
		sb.showStatus("You've got "+all+" out of "+count+" right ["+
				all+"/"+count+"]. getting there...");
	} else if (count-1 >= all) {
		sb.showStatus("You've got "+all+" out of "+count+" right ["+
				all+"/"+count+"]. ONE more...");
	}
	if (all == count) {
		return true;
		// System.out.println("YIPPEAAAAAAAAAAAAAAAAAAAAAA");
	}
	return false;
}

public boolean mouseUp(Event e, int x, int y)  {
	if (pieces.inside(x,y))  {
		move = false;
		frame.setCursor(Frame.WAIT_CURSOR);
		moveTo(x, y);
		pCv.repaint();
		if (checkResult()) {
			sb.showStatus("Finished! Congratulations.");
			if (successPopup) {
				Yippea yip = new Yippea();
				yip.resize(400, 180);
				yip.show();
			}
			finished = true;
		}
		frame.setCursor (Frame.DEFAULT_CURSOR);
	} else  {
		move = false;
	}
	return true;
}

public boolean handleEvent(Event evt)  {
	switch(evt.id)  {
		case Event.ACTION_EVENT:  {
			if ("About".equals(evt.arg))  {
				Insets i = ab.insets();
				ab.resize(380+i.left+i.right,200+i.top+i.bottom);
				ab.show();
				// aboutButton.disable();
				pCv.repaint();
			}
			if ("Shuffle".equals(evt.arg))  {
				frame.setCursor(Frame.WAIT_CURSOR);
				// img=shuffle(img);
				splitImage(startImage, rows, cols);
				while (checkResult()) {
					sb.showStatus("shuffling again ....");
					splitImage(startImage, rows, cols);
				}
				pCv.repaint();
				frame.setCursor(Frame.DEFAULT_CURSOR);
			}
			if ("Show Result".equals(evt.arg))  {
				Insets i = rs.insets();
				rs.pack();
				// with +40 for pic and +30 for menu
				rs.resize(imgSize[0]*rows+i.left+i.right, 
						imgSize[1]*cols+70+i.top+i.bottom);  
				rs.show();
				rs.repaint();
				resultButton.setLabel("Hide Result");
				pCv.repaint();
			}
			if ("Hide Result".equals(evt.arg))  {
				rs.hide();
				resultButton.setLabel("Show Result");
			}
			if ("Update Image".equals(evt.arg))  {
				rows = ppRows.getValue();
				cols = ppCols.getValue();
				frame.setCursor(Frame.WAIT_CURSOR);
				img = splitImage(startImage, rows, cols);
				if (mt != null) {
					try {
						mt.waitForAll();
			 		} catch (InterruptedException e) {}
		 		}
				while (checkResult()) {
					sb.showStatus("shuffling again ....");
					splitImage(startImage, rows, cols);
				}
		 		pCv.repaint();
				frame.setCursor(Frame.DEFAULT_CURSOR);
			}
		}
		default:
			return super.handleEvent(evt);
	}
}

} // end of class puzzle
